/*
 * (C) Copyright 2014 Kurento (http://kurento.org/)
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Lesser General Public License
 * (LGPL) version 2.1 which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/lgpl-2.1.html
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 */

#ifndef _OtimizedGstBuffer_H_
#define _OtimizedGstBuffer_H_

#include "asn_application.h"

#include <gst/gst.h>
#include "GstBuffer.h"

#ifdef __cplusplus
extern "C" {
#endif

/* OptimizedGstBuffer */
typedef struct OptimizedGstBuffer {
  GstBuffer_t buffer; /* Inherit from Marshallable GstBuffer_t */

  GstBuffer *gstbuffer; /* the gstreamer buffer */
} OptimizedGstBuffer_t;

/* Implementation */
extern asn_TYPE_descriptor_t asn_DEF_OptimizedGstBuffer;

#ifdef __cplusplus
}
#endif

#endif /* _OtimizedGstBuffer_H_ */
#include "asn_internal.h"