/*
 * (C) Copyright 2014 Kurento (http://kurento.org/)
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Lesser General Public License
 * (LGPL) version 2.1 which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/lgpl-2.1.html
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 */

#ifndef _G_MARSHAL_TYPES_
#define _G_MARSHAL_TYPES_

#include "marshal.h"
#include "GValue.h"
#include "GstStructure.h"
#include "GstCaps.h"
#include "GstBuffer.h"
#include "KmsProtocolMessage.h"

GValue_t * get_marshallable_GValue (const GValue * value, KurentoMarshalRules rules,
    gchar * buf, gsize size, GError ** err);
GValue * get_GValue (const GValue_t * val, KurentoMarshalRules rules, GError ** err);

gssize enc_GValue (KurentoMarshalRules rules, const GValue * value, gchar *buf,
    gsize size, GError ** err);
gboolean dec_GValue (KurentoMarshalRules rules, const gchar * buf, gsize size,
    GValue ** value, GError ** err);

GstStructure_t * get_marshallable_gststructure (const GstStructure * structure,
    KurentoMarshalRules rules, gchar * buf, gsize size, GError ** err);
GstStructure * get_GstStructure (const GstStructure_t * structure,
    KurentoMarshalRules rules, GError ** e);

gssize enc_GstStructure (KurentoMarshalRules rules, const GstStructure * structure,
    gchar *buf, gsize size, GError ** err);
gboolean dec_GstStructure (KurentoMarshalRules rules, const gchar * buf, gsize size,
    GstStructure ** structure, GError ** err);

GstCaps_t * get_marshallable_GstCaps (const GstCaps * caps,
    KurentoMarshalRules rules, gchar * buf, gsize size, GError ** err);

GstBuffer_t * get_marshallable_GstBuffer (const GstBuffer * buffer,
    KurentoMarshalRules rules, gchar * buf, gsize size, GError ** err);

#endif /* _G_MARSHAL_TYPES_ */
